<?php

function connectDB($dbname, $user="Hier den Nutzer eintragen", $pw="hier Passwort eintragen") {  // if no argument than use default value "phpuser"; that is the login at the database -> must immediately created before use!
	$db = mysqli_connect("localhost", $user, $pw, $dbname);
	if(!$db){
		$db_result = FALSE;
		return $db_result;
	} else {
		mysqli_set_charset($db, 'utf8');
		return $db;
	}
}

function createTable($db, $tablename, $fields) {		//dbname= string 'DB-Name'; fields= 'id' INT (10),'name' VARCHAR(64),'and so on...
	$sqlfields = 'CREATE TABLE `'.$tablename.'` (`id` INT(10) NOT NULL AUTO_INCREMENT PRIMARY KEY, '.$fields.');';
	if (ifTableExist($db, $tablename) == FALSE) {
		$db_result = mysqli_query($db, $sqlfields) or die("Table create ERROR: ".mysqli_error($db));
		return $db_result;
	} else return FALSE;
}

function addData($db, $tablename, $field, $data) {		//add dates like is declared in $data
	$newEntry = 'INSERT INTO `'.$tablename.'` ('.$field.') VALUES('.$data.');';
//	echo $newEntry;
	mysqli_query($db, $newEntry) or die("Data insert ERROR: ".mysqli_error($db));
	return mysqli_insert_id($db);
}

function ifTableExist($db, $dbtable, $orderby=" ") {	//asked if there data into a table -> if not, than result false or the dates, if something exist [if something->like order by]
	$ifTable = 'SELECT * FROM `'.$dbtable.'` '.$orderby.';';
	$db_result = mysqli_query($db, $ifTable);
	if ($db_result) return $db_result;
	else return FALSE;
}

function createDatabase($db, $dbname) {		//create a database; imported is login to the database and its rights, value two is the new name of table
	$sqlname = 'CREATE DATABASE IF NOT EXISTS '.$dbname;
	$db_result = mysqli_query($db, $sqlname) or die("Database create ERROR: ".mysqli_error($db));
	return $db_result;
}

function queryFromTable($db, $dbtable, $orderby, $start=0,$length=1) {		// asked for data in the database [options are order, start or length] 
	$db_result = ifTableExist($db, $dbtable, $orderby);
	if ($db_result == FALSE) return FALSE;	//break, because no data everywhere
	$data = array();
	while ($obj=mysqli_fetch_object($db_result)) {	//fetch the contents
		array_push($data, $obj);
	}
	return $data;
}

function searchEntry($db,$table,$field,$value, $limit="1") {		//search a entry into the database like the mentioned in field; common used is by LIMIT=one
	$sqlsearch = "SELECT * FROM $table WHERE $field = '$value' LIMIT $limit";
	$data = array();
	$db_result = mysqli_query($db, $sqlsearch);
	if ($db_result->num_rows > 0) {
		while ($obj=mysqli_fetch_object($db_result)) {	//fetch the contents
			array_push($data, $obj);
		}
	return $data;
	}
	else return FALSE;
}

function searchEntriesOrderBy($db,$table,$field,$value,$orderby) {		//search a entry into the database like the mentioned in field; 
	$sqlsearch = "SELECT * FROM $table WHERE $field = '$value' ORDER BY $orderby";
	$data = array();
	$db_result = mysqli_query($db, $sqlsearch);
	if ($db_result->num_rows > 0) {
		while ($obj=mysqli_fetch_object($db_result)) {	//fetch the contents
			array_push($data, $obj);
		}
	return $data;
	}
	else return FALSE;
}

function updateData($db, $tablename, $id, $field, $data) { // UPDATE FFWParty SET BookedAdult=20 WHERE id=1
	$updateEntry = "UPDATE $tablename SET $field = '$data' WHERE id= '$id'";
	$db_result = mysqli_query($db, $updateEntry) or die("Data update ERROR: ".mysqli_error($db));
	return $db_result;	
}

function searchEntryLike($db,$table,$field,$value) {		//search  entries into the database by use like operator
	$sqlsearch = "SELECT * FROM $table WHERE $field LIKE '$value'"; 
	$data = array();
	$db_result = mysqli_query($db, $sqlsearch);
	if ($db_result->num_rows > 0) {
		while ($obj=mysqli_fetch_object($db_result)) {	//fetch the contents
			array_push($data, $obj);
		}
	return $data;
	}
	else return FALSE;
}

function lockTable($db, $table, $action="UNLOCK") { // table lock or unlock for exclusive open
	if($action == "UNLOCK") $sqlLock = "UNLOCK TABLE";
	else $sqlLock = "LOCK TABLE $table WRITE";
	$db_result = mysqli_query($db, $sqlLock) or die("Table LOCK ERROR: ".mysqli_error($db));
	return $db_result;	
}

function deleteEntryById($db,$table,$id) {			// delete a entry for ever by ID (ID is the singular property of one entry into the database and table)
	$sqldelete = "DELETE FROM $table WHERE id=$id LIMIT 1";  // delete one entry only, by order "LIMIT 1"
	$db_result = mysqli_query($db, $sqldelete) or die("Data delete ERROR: ".mysqli_error($db));
	if ($db_result) return TRUE;
	else return FALSE;
}

function closeDatabase($db) {			// simply close every questions at the database
	mysqli_close($db);
}

function clearContent($inhalt='') {	//changed the string into a endangered string and beware the browser to execute Java-scripts from user-entries
    $inhalt = trim($inhalt);
	$changeArray = Array("ä" => "ae", "ü" => "ue", "ö" => "oe", "Ä" => "Ae", "Ü" => "Ue", "Ö" => "Oe","ß" => "ss","á"=>"a","Á"=>"A","é"=>"e","è"=>"e","ê"=>"e","É"=>"E");
	$inhalt = strtr($inhalt, $changeArray);
    $inhalt = htmlentities($inhalt, ENT_QUOTES, "UTF-8");
    return($inhalt);
}

function saveIntoUploads($img, $path = "uploads"){
     
	if (strpos($img, 'data:image/jpeg;base64,') === 0) {
		$img = str_replace('data:image/jpeg;base64,', '', $img);  
		$ext = '.jpg';
	}
	if (strpos($img, 'data:image/png;base64,') === 0) {
		$img = str_replace('data:image/png;base64,', '', $img); 
		$ext = '.png';
	}
   
  $img = str_replace(' ', '+', $img);
  $data = base64_decode($img);
  $fileName = 'img'.date("YmdHis").$ext;
   
  file_put_contents($path.'/'.$fileName, $data);
  return $fileName;
	
}
?>