<!DOCTYPE html>
<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=ISO-8859-1">
<meta name="viewport" content="width=600", "initial-scale=1.0">  <!-- Einstellung für mobile Geräte für die richtige Anzeige-->
<link rel="stylesheet" href="mydesign.css">
<title>Stromverbrauch</title>
<style>
button {
  border: none;
  text-align: center;
  text-decoration: none;
  display: inline-block;
  font-size: 16px;
  cursor: pointer;
}
</style>
</head>
<body>
<?php
if( isset($_REQUEST['timestamp']))
	$date = $_GET['timestamp'];
else
	$date = time();

$searchDatum = date("yy-m-d",$date);
$ShowDatum = date("d.m.yy",$date);

require 'inc/dbconnect.php';
$db = connectDB("dtzlogger");	// Zugriff auf sql Datenbank
$result = searchEntryLike($db, "dtzdata","timestamp", $searchDatum."%"); //welche Tabelle und sortiert nach was, inverse.
closeDatabase($db);
?>
<!----------------------- begin of HTML ------------------------------>
<center>
<!----------------------- header design ------------------------------>
<div class="input">
	<div id="headline" class="box title">
		
		<h1>Strom-Verbrauchsanzeige</h1>
	</div>
</div>
<!----------------------- disclaimer --------------------------------->
<div class="input"><center>
 <br> Strom-Verbrauchsdaten als Digramm-Anzeige.
 </center><br>
 <table class="consumtion"><tr>
	<th></th><th class="consumtion">Verbrauchsdaten für den:</th>
	<th id="datum_day" class="consumtion"><?php echo $ShowDatum;?></th></tr>
	<th></th><th class="consumtion">Tages-Gesamtverbrauch: </th>
	<th id="kwh_per_day">000</th><th> kWh</th></tr>
	<tr>
	<th></th><th class="consumtion">Tages-Endzählerstand: </th>
	<th id="actual_kwh">00000</th><th> kWh</th></tr>
	</tr></table>
 <br>
</div>
<!----------------------- content ------------------------------------>
<div class="input">
	<canvas id="kwh_diagramm" style="border:2px solid skyblue;border-radius:8px;">Sorry, dein Browser unterstützt leider die Darstellung nicht. Versuche es bitte mit einen modernen Browser.</canvas>
	<table class="change_consumtion_scale"><tr>
		<th><image id="kwh_sub" class="iconmini submini"></image></th>
		<th><image id="kwh_add" class="iconmini plusmini"></image></th>
		<th class="zoom" id="ShowKwhZoom"></th>
	</tr></table>
	
	<canvas id="voltage_diagramm" style="border:2px solid skyblue;border-radius:8px;"></canvas>
	<table class="change_voltage_scale"><tr>
		<th><image id="voltage_sub" class="iconmini submini"></image></th>
		<th><image id="voltage_add" class="iconmini plusmini"></image></th>
		<th class="zoom" id="ShowVoltZoom"></th>
	</tr></table>
	
	<canvas id="current_diagramm" style="border:2px solid skyblue;border-radius:8px;"></canvas>
	<table class="change_current_scale"><tr>
		<th><image id="current_sub" class="iconmini submini"></image</th>
		<th><image id="current_add" class="iconmini plusmini"></image></th>
		<th class="zoom" id="ShowCurrentZoom"></th>
	</tr></table>
	
	<center>
	<table class="change_month"><tr>
		<th><image id="buttonback" class="arrowLink arrowLeft"></image></th>
		<th id="ShowDatum"><?php echo $ShowDatum;?></th>
		<th><image id="buttonnext" class="arrowLink arrowRight"></image></th>
	</tr></table></center>

</div>
<div class="showtext">
<center><button id="buttontoday">Anzeige Heute</button></center>
</div>
<!----------------------- footer design ------------------------------>
<footer class="showtext"><center>
	<table>
		<tr>
		<th><a href="javascript:history.back()"><img  src="./picture/arrowback.png" alt="Hauptseite"></a></th>
		<th><a href="javascript:history.back()" class="main"><p>zurück zur Hauptseite</p></a></th>
		<th><img src="./picture/empty.png"></th>
		<th><a href="impressum.html" class="main"><p>Impressum und Datenschutzerklärung</p></a></th>
		</tr>
	</table>
</footer>
</center>

<!----------------------- java script code --------------------------->

<script type="text/javascript">
// canvas-body temperature
var canvasKWH = document.getElementById("kwh_diagramm");
var canvasWidth = 591;
var canvasHeight = 200;
canvasKWH.setAttribute('width', canvasWidth);
canvasKWH.setAttribute('height', canvasHeight);
var cvKwh = canvasKWH.getContext("2d");
// canvas-body humidity
var canvasVoltage = document.getElementById("voltage_diagramm");
canvasVoltage.setAttribute('width', canvasWidth);
canvasVoltage.setAttribute('height', canvasHeight);
var cvVolt = canvasVoltage.getContext("2d");
// canvas-body pressure
var canvasCurrent = document.getElementById("current_diagramm");
canvasCurrent.setAttribute('width', canvasWidth);  // use the same dimensions like humidity
canvasCurrent.setAttribute('height', canvasHeight); // use the same dimensions like humidity
var cvCurrent = canvasCurrent.getContext("2d");
// Data Graph
var result=<?php echo json_encode($result); ?>;	// result->id; result->date; result->time; result->tgnd; result->tobn
var datum = [];
var date = new Date();
var dummy = 0;
var KwhZoom = 1;
var VoltZoom = 10;
var CurrentZoom = 10;

DrawDiagram();				// for the first time when create the page on user call draw canvas function

setInterval(function() {CheckRefresh()},300*1000); 		// auto-refresh every 15 minutes (900 sec * 1000 = ms)
function CheckRefresh() {
	d = new Date();
	if(date.getDate() == d.getDate() && date.getMonth() == d.getMonth()) {
		getNewDay(Date.parse(new Date()));
	}
}

function DrawDiagram(){		// create as a function because is called if data has changed
	cvKwh.clearRect(0, 0, canvasWidth, canvasHeight);	// clear old data on screen
	cvVolt.clearRect(0, 0, canvasWidth, canvasHeight);	// clear old data on screen
	cvCurrent.clearRect(0, 0, canvasWidth, canvasHeight);	// clear old data on screen
//Options Grid
	var graphGridSize = 50;
	var graphGridX = (canvasWidth / graphGridSize).toFixed();
//Draw Grid
	cvKwh.beginPath();
	cvVolt.beginPath();
	cvCurrent.beginPath();
	for(var i = 0; i < graphGridX; i ++){
		cvKwh.moveTo(canvasWidth, graphGridSize*i);
		cvKwh.lineTo(0, graphGridSize*i);
		cvVolt.moveTo(canvasWidth, graphGridSize*i);
		cvVolt.lineTo(0, graphGridSize*i);
		cvCurrent.moveTo(canvasWidth, graphGridSize*i);
		cvCurrent.lineTo(0, graphGridSize*i);
	}
	cvKwh.strokeStyle = "#dbdbdb";
	cvKwh.stroke();
	cvVolt.strokeStyle = "#dbdbdb";
	cvVolt.stroke();
	cvCurrent.strokeStyle = "#dbdbdb";
	cvCurrent.stroke();
	cvKwh.closePath();
	cvVolt.closePath();
	cvCurrent.closePath();

	var dtzdata =[];
	var ActKwh = 0;
	let MaxVolt = 0;
	let MinVolt = 5000;
	let MaxCurrent = 0;
	let MinCurrent = 10000;
	let MaxFreq = 0;
	let MinFreq = 600;
	if (result) {
		datum.pop();			// delete datum for push new one
		result.forEach(function (v, i){
			item =[];
			var ts = new Date(v.timestamp);
			dummy = ts.getHours()*4;	// every 15th minutes is a value. Then is at the end of day there are 96 values
			dummy += ts.getMinutes()/15;
			item.push(dummy.toFixed());  // without values after decimal place
			item.push(v.fromgrid);
			item.push(v.intogrid);
			item.push(Number(v.ul1));
			item.push(Number(v.ul2));
			item.push(Number(v.ul3));
			item.push(Number(v.il1));
			item.push(Number(v.il2));
			item.push(Number(v.il3));
			item.push(Number(v.freq));
			dtzdata.push(item);
			datum.push(v.timestamp);
		
			ActKwh = v.fromgrid;
			
		if (item[3] > MaxVolt) MaxVolt = item[3];
		if (item[4] > MaxVolt) MaxVolt = item[4];
		if (item[5] > MaxVolt) MaxVolt = item[5];

		if (item[3] < MinVolt) MinVolt = item[3];
		if (item[4] < MinVolt) MinVolt = item[4];
		if (item[5] < MinVolt) MinVolt = item[5];

		if (item[6] > MaxCurrent) MaxCurrent = item[6];
		if (item[7] > MaxCurrent) MaxCurrent = item[7];
		if (item[8] > MaxCurrent) MaxCurrent = item[8];
		
		if (item[6] < MinCurrent) MinCurrent = item[6];
		if (item[7] < MinCurrent) MinCurrent = item[7];
		if (item[8] < MinCurrent) MinCurrent = item[8];

		if (item[9] > MaxFreq) MaxFreq = item[9];
		if (item[9] < MinFreq) MinFreq = item[9];
	});
//Options Graph
//console.log(dtzdata);
	var graphMaxKwh = 1500;
	var graphMaxVolt = 300;
	var graphMaxCurrent = 5000;
	var graphPadding = 10;
	var graphFaktorKwh = (canvasHeight-(2*graphPadding)) / graphMaxKwh;
	var graphFaktorVolt = (canvasHeight-(2*graphPadding)) / graphMaxVolt;
	var graphFaktorCurrent = (canvasHeight-(2*graphPadding)) / graphMaxCurrent;
	var graphWidth = (canvasWidth-graphPadding) / (24 *4);
	cvKwh.font = "10px Verdana";
//Draw Graph Consumption
	var consumWholeDay = dtzdata[dtzdata.length-1][1]-dtzdata[0][1];
	var consumMax = 0;
	var consumMin = 10000;
	for(var i = 0; i < 96; i ++){
		KwhPerQuarter = 0;
		var ShowKwh = 0;
		for (x=1; x < dtzdata.length; x++){
			if (dtzdata[x][0] == i ) {KwhPerQuarter = ((dtzdata[x][1]-dtzdata[x-1][1]) * KwhZoom);
				if (KwhPerQuarter < consumMin) consumMin = KwhPerQuarter;
				if (KwhPerQuarter > consumMax) consumMax = KwhPerQuarter;
			}
		}
// console.log(KwhPerQuarter);	
		Top = ((canvasHeight +180) -(graphFaktorKwh*KwhPerQuarter)).toFixed()/2;
		Height = ((graphFaktorKwh *KwhPerQuarter)).toFixed()/2;
		cvKwh.fillStyle = "green"; // show green
		cvKwh.fillRect(graphWidth+((i-1)*graphWidth)+5, Top, graphWidth-1, Height);
		cvKwh.fillStyle = "black";
		if(i == 0){
			cvKwh.fillText("Time:", 1, canvasHeight-2, graphWidth*4);
		}
		else {
			if(i % 4 == 0){
				cvKwh.fillText(i/4, graphWidth+((i-1)*graphWidth)+graphPadding-8, canvasHeight-2, graphWidth*4);
			}
		}
	}
	cvKwh.fillStyle = "gray";
	if(KwhZoom == 1){
		cvKwh.fillText("0,07", 1, (canvasHeight/4*3) -1, graphWidth*6);
		cvKwh.fillText("0,15", 1, (canvasHeight/2) -1, graphWidth*6);
		cvKwh.fillText("0,22", 1, (canvasHeight/4) -1, graphWidth*6);
		cvKwh.fillText("kWh", 1, (canvasHeight/4) -10, graphWidth*6);
	}
	cvKwh.fillStyle = "darkblue";
	cvKwh.font = "14px Verdana";
	cvKwh.fillText("Verbrauch min: "+(consumMin/KwhZoom/10000).toFixed(2) +" kWh / max: "+ (consumMax/KwhZoom/10000).toFixed(2) +" kWh (pro 15 Minuten)" , 6, 15);
	document.getElementById("kwh_per_day").innerHTML = (consumWholeDay/10000).toFixed(2);
	document.getElementById("actual_kwh").innerHTML = (ActKwh/10000).toFixed(2);

//Draw Graph voltage L1
	cvVolt.beginPath();
	for(var i = 0; i < 96; i ++){
		VoltPerQuarter = -1;
		for (x=0; x < dtzdata.length; x++){
			if (dtzdata[x][0] == i ) VoltPerQuarter = (((dtzdata[x][3]*VoltZoom)-(MinVolt)*(VoltZoom-1))/10)-150;
		}
		TopVolt = ((canvasHeight) -(graphFaktorVolt*VoltPerQuarter)).toFixed();
		HeightVolt = ((graphFaktorVolt *VoltPerQuarter)).toFixed();
		cvVolt.strokeStyle = "blue";
		if(VoltPerQuarter>-1) {
			cvVolt.lineTo(graphWidth+((i-1)*graphWidth), TopVolt);
			cvVolt.stroke();
		}
	}
	cvVolt.closePath();
//Draw Graph voltage L2
	cvVolt.beginPath();
	for(var i = 0; i < 96; i ++){
		VoltPerQuarter = -1;
		for (x=0; x < dtzdata.length; x++){
			if (dtzdata[x][0] == i ) VoltPerQuarter = (((dtzdata[x][4]*VoltZoom)-(MinVolt)*(VoltZoom-1))/10)-150;
		}
		TopVolt = ((canvasHeight) -(graphFaktorVolt*VoltPerQuarter)).toFixed();
		HeightVolt = ((graphFaktorVolt *VoltPerQuarter)).toFixed();
		cvVolt.strokeStyle = "brown";
		cvVolt.lineTo(graphWidth+((i-1)*graphWidth), TopVolt);
		if(VoltPerQuarter>-1) {
			cvVolt.lineTo(graphWidth+((i-1)*graphWidth), TopVolt);
			cvVolt.stroke();
		}
	}
	cvVolt.closePath();
//Draw Graph voltage L3
	cvVolt.beginPath();
	for(var i = 0; i < 96; i ++){
		VoltPerQuarter = -1;
		for (x=0; x < dtzdata.length; x++){
			if (dtzdata[x][0] == i ) VoltPerQuarter = (((dtzdata[x][5]*VoltZoom)-(MinVolt)*(VoltZoom-1))/10)-150;
		}
		TopVolt = ((canvasHeight) -(graphFaktorVolt*VoltPerQuarter)).toFixed();
		HeightVolt = ((graphFaktorVolt *VoltPerQuarter)).toFixed();
		cvVolt.strokeStyle = "red";
		cvVolt.lineTo(graphWidth+((i-1)*graphWidth), TopVolt);
		if(VoltPerQuarter>-1) {
			cvVolt.lineTo(graphWidth+((i-1)*graphWidth), TopVolt);
			cvVolt.stroke();
		}
	}
	cvVolt.closePath();
	cvVolt.fillStyle = "darkblue";
	cvVolt.font = "14px Verdana";
	cvVolt.fillText("Spannung min: "+ MinVolt/10 +" V" + " / max: "+MaxVolt/10 +" V", 6, 15);	
	
//Draw Graph current L1
	cvCurrent.beginPath();
	for(var i = 0; i < 96; i ++){
		CurrentPerQuarter = -1;
		for (x=0; x < dtzdata.length; x++){
			if (dtzdata[x][0] == i ) CurrentPerQuarter = (dtzdata[x][6])*CurrentZoom;
		}
		TopCurrent = ((canvasHeight) -(graphFaktorCurrent*CurrentPerQuarter)).toFixed();
		HeightCurrent = ((graphFaktorCurrent *CurrentPerQuarter)).toFixed();
		cvCurrent.strokeStyle = "blue";
		cvCurrent.lineTo(graphWidth+((i-1)*graphWidth), TopCurrent);
		if(CurrentPerQuarter>-1)cvCurrent.stroke();
	}
	cvCurrent.closePath();
//Draw Graph current L2
	cvCurrent.beginPath();
	for(var i = 0; i < 96; i ++){
		CurrentPerQuarter = -1;
		for (x=0; x < dtzdata.length; x++){
			if (dtzdata[x][0] == i ) CurrentPerQuarter = (dtzdata[x][7])*CurrentZoom;
		}
		TopCurrent = ((canvasHeight) -(graphFaktorCurrent*CurrentPerQuarter)).toFixed();
		HeightCurrent = ((graphFaktorCurrent *CurrentPerQuarter)).toFixed();
		cvCurrent.strokeStyle = "brown";
		cvCurrent.lineTo(graphWidth+((i-1)*graphWidth), TopCurrent);
		if(CurrentPerQuarter>-1)cvCurrent.stroke();
	}
	cvCurrent.closePath();
//Draw Graph current L3
	cvCurrent.beginPath();
	for(var i = 0; i < 96; i ++){
		CurrentPerQuarter = -1;
		for (x=0; x < dtzdata.length; x++){
			if (dtzdata[x][0] == i ) CurrentPerQuarter = (dtzdata[x][8])*CurrentZoom;
		}
		TopCurrent = ((canvasHeight) -(graphFaktorCurrent*CurrentPerQuarter)).toFixed();
		HeightCurrent = ((graphFaktorCurrent *CurrentPerQuarter)).toFixed();
		cvCurrent.strokeStyle = "red";
		cvCurrent.lineTo(graphWidth+((i-1)*graphWidth), TopCurrent);
		if(CurrentPerQuarter>-1)cvCurrent.stroke();
	}
	cvCurrent.closePath();

	cvCurrent.fillStyle = "darkblue";
	cvCurrent.font = "14px Verdana";
	cvCurrent.fillText("Strom min: "+ (MinCurrent/100) +" A" + " / max: "+ (MaxCurrent/100) +" A", 6, 15);	
}
}
<!----------------------- get new data ------------------------------>
//calculate new date
document.getElementById('buttonback').addEventListener('click', function() {getNewDay(Date.parse(date)-86400000)});
document.getElementById('buttonnext').addEventListener('click', function() {getNewDay(Date.parse(date)+86400000)});
document.getElementById('buttontoday').addEventListener('click', function() {getNewDay(Date.parse(new Date()))});
//adjust temperature
document.getElementById('kwh_sub').addEventListener('click', function() {KwhZoomOut()});
document.getElementById('kwh_add').addEventListener('click', function() {KwhZoomIn()});
//adjust humidity
document.getElementById('voltage_sub').addEventListener('click', function() {VoltZoomOut()});
document.getElementById('voltage_add').addEventListener('click', function() {VoltZoomIn()});
//adjust pressure
document.getElementById('current_sub').addEventListener('click', function() {CurrentZoomOut()});
document.getElementById('current_add').addEventListener('click', function() {CurrentZoomIn()});

function KwhZoomIn() {
	if (KwhZoom < 3) KwhZoom++;
	document.getElementById("ShowKwhZoom").innerHTML = KwhZoom + " * Zoom";
	DrawDiagram();
}
function KwhZoomOut() {
	if (KwhZoom > 1) KwhZoom--;
	if (KwhZoom != 1) document.getElementById("ShowKwhZoom").innerHTML = KwhZoom + " * Zoom";
	else document.getElementById("ShowKwhZoom").innerHTML = "";
	DrawDiagram();
}
function VoltZoomIn() {
	if (VoltZoom < 20) VoltZoom++;
	if (VoltZoom != 10) document.getElementById("ShowVoltZoom").innerHTML = (VoltZoom-10) + " * Zoom";
	else document.getElementById("ShowVoltZoom").innerHTML = "";
	DrawDiagram();
}
function VoltZoomOut() {
	if (VoltZoom > 1) VoltZoom--;
	if (VoltZoom != 10) document.getElementById("ShowVoltZoom").innerHTML = (VoltZoom-10) + " * Zoom";
	else document.getElementById("ShowVoltZoom").innerHTML = "";
	DrawDiagram();
}
function CurrentZoomIn() {
	if (CurrentZoom < 20) CurrentZoom++;
	if (CurrentZoom != 10) document.getElementById("ShowCurrentZoom").innerHTML = (CurrentZoom-10) + " * Zoom";
	else document.getElementById("ShowCurrentZoom").innerHTML = "";
	DrawDiagram();
}
function CurrentZoomOut() {
	if (CurrentZoom > 1) CurrentZoom--;
	if (CurrentZoom != 10) document.getElementById("ShowCurrentZoom").innerHTML = (CurrentZoom-10) + " * Zoom";
	else document.getElementById("ShowCurrentZoom").innerHTML = "";
	DrawDiagram();
}
//get new data from server for a new or previous day
function getNewDay(timestamp) {	// this is the entry for request to server of new data
	if (timestamp > Date.parse(new Date())) { timestamp = Date.parse(new Date())} // no search of days in the future of today
	timestamp = timestamp / 1000;	// change from ms to seconds
	var xmlhttp = new XMLHttpRequest();
    xmlhttp.onreadystatechange = function() {
		if (this.readyState == 4 && this.status == 200) {	// 200 means -> all data received
			var getReturn = JSON.parse(this.responseText);	// receive  json and translate it
			if (getReturn["code"] == '200'){
//				console.log(this.responseText);	
				date = new Date(getReturn["date"]);	// get the searchdate
				result=getReturn["data"];					// get data as json, if nothing received then "data":false
				DrawDiagram();								// redraw diagram
				document.getElementById("ShowDatum").innerHTML = date.getDate()+"."+(date.getMonth()+1)+"."+date.getFullYear(); // show 
				document.getElementById("datum_day").innerHTML = document.getElementById("ShowDatum").innerHTML;
			}
			else {
				document.getElementById('headline').innerHTML = "ERROR Code:"+ this.responseText;
				console.log(this.responseText);	
			}
		}
	};
	xmlhttp.open("GET", "dtz2dbase.php?action=newdata&timestamp=" + timestamp, true);	// return is a json
	xmlhttp.send();
}

//console.log(tgnd);	

</script>
</body>
</html>


























